
	TITLE	SWDRIVER - Interface to BIN loadable drivers (reentrant).
	NAME SWDRENTRY

	COMMENT	$

		Written and (c) by Dave Stampe 20/8/92
		Not for commercial use, so get permission
		before marketing code using this stuff!
		For private PD use only.

		This code uses a far stack in TINY model.  Either your driver must
		use assembler with .MODEL tiny farstack only or it must use C
		in the tiny model with NO library calls.

		This is for drivers that will be used from interrupts, thus
		must be reentrant, i.e. the switcher driver.

		$

		.MODEL tiny farstack
		.CODE

extrn	_driver_entry           ; the links to the routines

		; 16 bytes can be trimmed to align in segment
	rept 16
	db '#'
	endm

	.386

drlink:
	push	bp
	push	ds
	mov	bp,sp
	push	DWORD PTR ss:[bp+24]   ; up to 20 bytes of arguments
	push	DWORD PTR ss:[bp+20]   ; copy adds 1 uS, but needed
	push	DWORD PTR ss:[bp+16]   ; to keep ints from crashing
	push	DWORD PTR ss:[bp+12]
	push	DWORD PTR ss:[bp+8]
	push	cs                              ; push default return
	push	offset rtnh
	push	cs
	pop	ds
	push	ds
	push	offset _driver_entry
	retf                                    ; "call"

rtnh:	mov	sp,bp
	pop	ds
	pop	bp
	retf                                    ; exit

	db 'REND386 Device Driver. 19/8/92 by Dave Stampe.'

	end

