/*****************************************/
/* Defines for  VGA256.BGI   driver      */
/*        By:  Markham Thomas            */
/*        Feb 3, 1989                    */
/*****************************************/

/*****************************************/
/*  NOTE:  This driver will work         */
/*         in all memory models except   */
/*         tiny.                         */
/*                                       */
/*   P.S. only use flashmodes with       */
/*       TSENG LABS based VGA boards.    */
/*****************************************/


#define  DVGA320x200   0               /* Designer VGA graphics modes */
#define  DVGA640x480   1
#define  DVGA800x600   2

 typedef struct {                      /* RGB structure */
    char Red;
    char Green;
    char Blue;
 } RGB;

 typedef char DACarray[256][3];        /* Array to hold DAC register values */

 enum { red=0,grn=1,blu=2 };           /* possible array indices for R, G, B */

void	           _Cdecl VGA256_driver(void);
extern int far  _Cdecl VGA256_driver_far[];
