
	TITLE	DRIVER - Interface to BIN loadable drivers (non-reentrant).
	NAME DRENTRY

	COMMENT	$

		Written and (c) by Dave Stampe 20/8/92
		Not for commercial use, so get permission
		before marketing code using this stuff!
		For private PD use only.

		This driver interface will support tiny or small model assembly or C.
		It has a private stack, thus the driver routines cannot be called
		from an interrupt	routine.  Use SWDRHEAD.ASM if this is required.

		$

		.MODEL tiny farstack
		.CODE

extrn	_driver_entry           ; the links to the routines

		; 16 bytes can be trimmed to align in segment
	rept 16
	db '#'
	endm

	.386

drlink: push	bp
	push	ds
	mov	  bp,sp
	mov	  dx,ss                  ; save stack seg
	mov	  es,dx
	push	cs                     ; new stack seg
	pop	  ss                     ; all int's disabled till next instr..
	mov	  sp,2000                ; stack internal to driver
	push	dx                     ; push old stack seg (bp=old stack ptr)
	push	DWORD PTR es:[bp+24]   ; up to 20 bytes of arguments
	push	DWORD PTR es:[bp+20]   ; copy adds 1 uS, but needed
	push	DWORD PTR es:[bp+16]   ; to keep ints from crashing
	push	DWORD PTR es:[bp+12]
	push	DWORD PTR es:[bp+8]
	push	cs                            ; push default return
	push	offset rtnh
	push	cs
	pop   ds
	push	ds
	push	offset _driver_entry
	retf                                    ; "call"

rtnh:
	add	sp,20
	pop	ss                              ; restore stack
	mov	sp,bp
	pop	ds
	pop	bp
	retf                                ; exit

	db 'REND386 Device Driver. 19/8/92 by Dave Stampe.'

	db 2000 dup ('S')      ; private stack

	end

